% Итерирует от MinIter до MaxIter включительно с шагом Step.
iter(MinIter, _Step, MaxIter, _Iter) :-
	MinIter > MaxIter,
	!, fail.
iter(MinIter, _Step, _MaxIter, MinIter).
iter(MinIter, Step, MaxIter, Iter) :-
	NextMinIter is MinIter + Step,
	iter(NextMinIter, Step, MaxIter, Iter).

% Задает время, большее StartTime, но не более чем на MaxTimeInt
timeGreater(MinTime, MaxTimeDifference, GreaterTime) :-
	timeSlice(MinTime),
	timeStep(TimeStep),
	toMillis(MaxTimeDifference, MaxTimeDifferenceMillis),
	iter(TimeStep, TimeStep, MaxTimeDifferenceMillis, TimeInt),
	GreaterTime is MinTime + TimeInt.

timeSmaller(MaxTime, MaxTimeDiff, SmallerTime) :-
	timeSlice(MaxTime),
	timeStep(TimeStep),
	toMillis(MaxTimeDiff, MaxTimeDifferenceMillis),
	iter(TimeStep, TimeStep, MaxTimeDifferenceMillis, TimeInt),
	SmallerTime is MaxTime - TimeInt,
	SmallerTime >= 0.

timeBetween(StartTime, FinishTime, Time) :-
	timeStep(TimeStep),
	timeSlice(StartTime),
	timeSlice(FinishTime),
	StartTime =< FinishTime,
	MaxTimeInt is FinishTime - StartTime,
	iter(0, TimeStep, MaxTimeInt, TimeInt),
	Time is StartTime + TimeInt.

devBeh(interacted(Pers1, Pers2), StartTime, FinishTime) :-
	timeStep(TimeStep),
	interact(Pers1, Pers2, StartTime),
	StartTimePrev is StartTime - TimeStep,
	timeSlice(StartTimePrev),
	\+ (interact(Pers1, Pers2, StartTimePrev)),
	interact(Pers1, Pers2, FinishTime),
	StartTime =< FinishTime,
	FinishTimeNext is FinishTime + TimeStep,
	timeSlice(FinishTimeNext),
	\+ (interact(Pers1, Pers2, FinishTimeNext)).

interact(Pers1, Pers2, Time) :-
	person(Pers1, Time),
	bounds(Pers1, Box1, Time),
	person(Pers2, Time),
	bounds(Pers2, Box2, Time),
	boxIntersection(Box1, Box2, BoxInt),
	area(BoxInt, IntersecArea),
	IntersecArea > 0.01.

boxIntersection(box(Xf1, Yf1, Xf2, Yf2), box(Xs1, Ys1, Xs2, Ys2), box(XInt1, YInt1, XInt2, YInt2)) :-
	XInt1 is max(Xf1, Xs1),
	YInt1 is max(Yf1, Ys1),
	XInt2 is min(Xf2, Xs2),
	YInt2 is min(Yf2, Ys2).

area(box(X1, Y1, X2, Y2), Area) :-
	X1 < X2,
	Y1 < Y2,
	Area is (X2 - X1) * (Y2 - Y1),
	!.
area(box(_, _, _, _), 0). 
